require "type0/version"
require 'net/http'
require 'json'
require 'aescrypt'
require 'openssl'
require 'base64'
require 'openssl/cipher'
require 'openssl/digest'
require 'yaml'


module Type0
   def self.initialize(file)
	parsed = begin
	 config=  YAML::load(IO.read(file))
	rescue ArgumentError => e
	  puts "There is no secret.yml file"
	end
	unless config["AppKey"].nil?
		$appid = config["AppId"] unless config["AppId"].nil?
		$app_key = config["AppKey"] 
	    encrypted_value = self.request_token($appid)
	   $token = self.decrypt(encrypted_value, $app_key)	
	end     
   end
 
 def self.request_token(app_key)
   uri = URI("https://typezero.herokuapp.com/api/auth/#{app_key}")
   res = Net::HTTP.get_response(uri)
   res = JSON.parse(res.body)['request_token']		
 end

 def self.send_mail(app_key, from, to,subject, body, cc , bcc)
	 uri = URI('https://typezero.herokuapp.com/api/send_mail')
	res = Net::HTTP.post_form(uri, { "token" =>$token , "key" =>$appid, "from" => from, "to" => to ,"subject" =>subject, "body" => body, "cc" => cc , "bcc" => bcc })
	puts res.body
 end 

 def self.decrypt(encrypted, key)
	base64_decoded = Base64.decode64(encrypted.to_s.strip)
	aes = OpenSSL::Cipher::Cipher.new('aes-256-cbc')
	aes.decrypt
	aes.key = Digest::SHA256.digest(key) 
	aes.iv  = '1234567890123456'
    aes.update(base64_decoded) + aes.final 
  end	
  

 def self.messages
    key = self.encrypt($appid.to_s, $app_key)
    uri = URI("https://typezero.herokuapp.com/api/messages/#{$token}/#{key.strip}") 
    res = Net::HTTP.get_response(uri)
    res = JSON.parse(res.body)
 end

 def self.encrypt(token, key)
	    aes = OpenSSL::Cipher::Cipher.new('aes-256-cbc')
		aes.encrypt
		aes.key = Digest::SHA256.digest(key) 
		aes.iv  = '1234567890123456'
	    encrypted = Base64.encode64( aes.update(token) << aes.final )
 end 

end
